import org.dom4j.Document;
import org.dom4j.DocumentFactory;
import org.dom4j.io.SAXReader;
import org.dom4j.Element;
import org.xml.sax.XMLReader;
import java.util.List;
import java.util.HashMap;
import java.util.regex.*;

public class HomeworkList {

  public static void main(String[] args) throws Exception {

    String studentName = args[0];
    Pattern namePattern = Pattern.compile(studentName,
      Pattern.CASE_INSENSITIVE);

    HashMap<String, String> map = new HashMap<String, String>();
    map.put("xhtml", "http://www.w3.org/1999/xhtml");
    DocumentFactory factory = DocumentFactory.getInstance();
    factory.setXPathNamespaceURIs(map);
    
    XMLReader tagsoup = new org.ccil.cowan.tagsoup.Parser();
    SAXReader reader = new SAXReader(tagsoup);
    EasyHTTPGet getter = new EasyHTTPGet(
      "http://itp.nyu.edu/varwiki/Classwork/A2Z-S09"
    );

    Document document = reader.read(getter.responseAsInputStream());
    List listItems = document.selectNodes("//xhtml:li");     

    for (Object o: listItems) {
      Element elem = (Element)o;
      String[] parts = elem.getText().split("/");
      Matcher m = namePattern.matcher(parts[0]);
      if (m.find()) {
        Element anchor = (Element)elem.selectSingleNode("xhtml:a");
        String project = anchor.getText();
        String href = anchor.attributeValue("href");
        System.out.println(project + " " + href);
      }
    }

  }

}
